clang 8.0.0

Public Types | Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::ento::Environment Class Reference

An immutable map from EnvironemntEntries to SVals. More...

`#include "clang/StaticAnalyzer/Core/PathSensitive/Environment.h"`

## Public Types
using | iterator = BindingsTy::iterator

## Public Member Functions
iterator | begin () const
iterator | end () const
SVal | getSVal (const EnvironmentEntry &E, SValBuilder &svalBuilder) const
| Fetches the current binding of the expression in the Environment. More...
void | Profile (llvm::FoldingSetNodeID &ID) const
| Profile - Used to profile the contents of this object for inclusion in a FoldingSet. More...
bool | operator== (const Environment &RHS) const
void | print (raw_ostream &Out, const char *NL, const char *Sep, const ASTContext &Context, const LocationContext *WithLC=nullptr) const

## Static Public Member Functions
static void | Profile (llvm::FoldingSetNodeID &ID, const Environment *env)
| Profile - Profile the contents of an Environment object for use in a FoldingSet. More...

## Friends
class | EnvironmentManager

## Detailed Description

An immutable map from EnvironemntEntries to SVals.

Definition at line 57 of file Environment.h.

## Member Typedef Documentation

## ◆ iterator

using clang::ento::Environment::iterator = BindingsTy::iterator

Definition at line 70 of file Environment.h.

## Member Function Documentation

## ◆ begin()

iterator clang::ento::Environment::begin | ( |  | ) | const
| inline

Definition at line 72 of file Environment.h.

Referenced by clang::ento::EnvironmentManager::removeDeadBindings().

## ◆ end()

iterator clang::ento::Environment::end | ( |  | ) | const
| inline

Definition at line 73 of file Environment.h.

Referenced by clang::ento::EnvironmentManager::removeDeadBindings().

## ◆ getSVal()

SVal Environment::getSVal | ( | const EnvironmentEntry & | E,
|  | SValBuilder & | svalBuilder
| ) |  | const

Fetches the current binding of the expression in the Environment.

Definition at line 85 of file Environment.cpp.

## ◆ operator==()

bool clang::ento::Environment::operator== | ( | const Environment & | RHS | ) | const
| inline

Definition at line 91 of file Environment.h.

## ◆ print()

void Environment::print | ( | raw_ostream & | Out,
|  | const char * | NL,
|  | const char * | Sep,
|  | const ASTContext & | Context,
|  | const LocationContext * | WithLC = `nullptr`
| ) |  | const

Definition at line 203 of file Environment.cpp.

## ◆ Profile() [1/2]

static void clang::ento::Environment::Profile | ( | llvm::FoldingSetNodeID & | ID,
|  | const Environment * | env
| ) |  |
| inline static

Profile - Profile the contents of an Environment object for use in a FoldingSet.

Definition at line 81 of file Environment.h.

Referenced by clang::ento::ProgramState::Profile().

## ◆ Profile() [2/2]

void clang::ento::Environment::Profile | ( | llvm::FoldingSetNodeID & | ID | ) | const
| inline

Profile - Used to profile the contents of this object for inclusion in a FoldingSet.

Definition at line 87 of file Environment.h.

References clang::ento::EnvironmentEntry::Profile().

## Friends And Related Function Documentation

## ◆ EnvironmentManager

friend class EnvironmentManager
| friend

Definition at line 59 of file Environment.h.

The documentation for this class was generated from the following files:

- include/clang/StaticAnalyzer/Core/PathSensitive/Environment.h
- lib/StaticAnalyzer/Core/Environment.cpp